% This file produces Figure 1 of Gagliardini, Scaillet (2011)


SS=1000;
S = [1/(SS+1):1/(SS+1):SS/(SS+1)]; % grid of probability levels

Z1  = importdata('QQ050_1.out'); % empirical quantiles of the Q-TiR estimate (l=1)
Z2  = importdata('QQ050_2.out'); % empirical quantile of the Q-TiR estimate (l=2)



S = -3 + 6*S; 
Z1= -3 + 6*Z1; 
Z2= -3 + 6*Z2;

T = [-3
     3];


subplot(1,2,1);
plot(Z1,S,'-b',T,T,'--r');
title('$x=0.50$, $l=1$, $\bar{\lambda}=\lambda=.00005$');
xlabel('Empirical quantile');
ylabel('N(0,1) quantile');
xlim([-3 3]);

subplot(1,2,2);
plot(Z2,S,'-b',T,T,'--r');
title('$x=0.50$, $l=2$, $\bar{\lambda}=\lambda=.000001$');
xlabel('Empirical quantile');
ylabel('N(0,1) quantile');
xlim([-3 3]);



