/* Estimation of functional parameter g */
/* Data of HS */
/* NIVQR */
/* Support of g : [0,1] */
/* Instrumental variable Z */
/* criterion: minimum distance criterion + lambda * Sobolev norm */
/* Chebyshev polynomials of order 0 to 15*/
/* Sobolev penalty of order 1 */
/* File name : normality_QTiR_HS_15.prg */

new;
library pgraph, optmum;
#include pgraph.ext;
#include optmum.ext

screen on;
print "Starting time" time;
time_start = time;

/* quantile probability level tau */

tau_1 = 0.50;

/* CI levels */

prob_up = .975;
prob_low = .025;

/* truncation for variance estimation */

n_t = 4;

/* loading the data */

load ixdtechg[18620,1] = "C:\\Documents and Settings\\OScaillet\\Mes documents\\gausspgm\\data_Hausman\\ixdtechg.txt";
load ixdtemin[18620,1] = "C:\\Documents and Settings\\OScaillet\\Mes documents\\gausspgm\\data_Hausman\\ixdtemin.txt";

load agec[18620,1] = "C:\\Documents and Settings\\OScaillet\\Mes documents\\gausspgm\\data_Hausman\\agec.txt";
load incomec[18620,1] = "C:\\Documents and Settings\\OScaillet\\Mes documents\\gausspgm\\data_Hausman\\incomec.txt";

load edhhc[18620,1] = "C:\\Documents and Settings\\OScaillet\\Mes documents\\gausspgm\\data_Hausman\\edhhc.txt";

load att[18620,1] = "C:\\Documents and Settings\\OScaillet\\Mes documents\\gausspgm\\data_Hausman\\att.txt";
load mci[18620,1] = "C:\\Documents and Settings\\OScaillet\\Mes documents\\gausspgm\\data_Hausman\\mci.txt";
load sprint[18620,1] = "C:\\Documents and Settings\\OScaillet\\Mes documents\\gausspgm\\data_Hausman\\sprint.txt"; 

interlata = ixdtechg ./  ixdtemin;
lmins = ixdtemin;
lincomec = ln(incomec);

/* Y, X, Z */

/* selection of variables based on years of education, operator, age */

e = (interlata .gt 0) .and (interlata .le 1) .and (edhhc .le 12) .and (att .gt 0) .and (agec .ge 30) .and (agec .le 45); 

/*  e = (interlata .gt 0) .and (interlata .le 1) .and (edhhc .gt 12) .and (att .gt 0) .and (agec .ge 30) .and (agec .le 45); */  

/* mapping of standardized data of Ystar, Xstar, Zstar in [0,1] via N(0,1) cdf */

ystar = selif(interlata, e);
/* y = cdfn((ystar-meanc(ystar))/stdc(ystar)); */
y = ystar;

xstar = selif(lmins, e);
x = cdfn((xstar-meanc(xstar))/stdc(xstar));

zstar = selif(lincomec, e); 
z = cdfn((zstar-meanc(zstar))/stdc(zstar));

/* Observed data */

obs = y~x~z;

/* Sample size */

T = rows(obs);

/* pilot regularisation parameter */

p_lambda = 0.0001; 

/* Reduction factor for regularization parameter to compute CI */

red_fac = .8;

/* Grid of Lagrange multiplier lambda */

grid_size = 1000;
low_lambda = 0.001;
up_lambda = 0.5;

step = (up_lambda - low_lambda)/(grid_size-1);
grid_lambda = seqa(low_lambda, step, grid_size);

/* vector of : j = 1,...,16 */

j_vec = {1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16};

/* computations of Sobolev norm */

/* coefficients c_{ii} of theta_i^2 of the quadratic form in theta */

c00 = 1/pi; c11 = 26/(3*pi); c22 = 218/(5*pi); c33 = 3898/(35*pi); c44 = 67894/(315*pi);
c55 = 82802/(231*pi); c66 = 2712298/(5005*pi); c77 = 4938266/(6435*pi); c88 = 158690690/(153153*pi);
c99 = 2181203602/(1616615*pi); c1010 = 4968962774/(2909907*pi); c1111 = 64253317834/(30421755*pi);
c1212 = 476573355722/(185910725*pi); c1313 = 1182462228154/(386122275*pi);
c1414 = 25020924278446/(6931814175*pi); c1515 = 84347110614902/(20056049013*pi);

/* coefficients c_{ij} of 2 theta_i theta_j , i \neq j, of the quadratic form in theta */

c01 = 0; c02 = -1/(3*pi)*sqrt(2); c03 = 0; c04 = -1/(15*pi)*sqrt(2); c05 = 0;
c06 = -1/(35*pi)*sqrt(2); c07 = 0; c08 = -1/(63*pi)*sqrt(2); c09 = 0;
c010 = -1/(99*pi)*sqrt(2); c011 = 0; c012 = -1/(143*pi)*sqrt(2); c013 = 0;
c014 = -1/(195*pi)*sqrt(2); c015 = 0;

c12 = 0; c13 = 38/(5*pi); c14 = 0; c15 = 166/(21*pi); c16 = 0; c17 = 358/(45*pi);
c18 = 0; c19 = 614/(77*pi); c110 = 0; c111 = 934/(117*pi); c112 = 0; c113 = 1318/(165*pi);
c114 = 0; c115 = 1766/(221*pi);

c23 = 0; c24 = 1182/(35*pi); c25 = 0; c26 = 10342/(315*pi); c27 = 0; c28 = 37502/(1155*pi);
c29 = 0; c210 = 8818/(273*pi); c211 = 0; c212 = 18842/(585*pi); c213 = 0; 
c214 = 390822/(12155*pi); c215 = 0;

c34 = 0; c35 = 5090/(63*pi); c36 = 0; c37 = 37714/(495*pi); c38 = 0; c39 = 372662/(5005*pi); c310 = 0;
c311 = 301474/(4095*pi); c312 = 0; c313 = 615554/(8415*pi); c314 = 0; c315 = 3365270/(46189*pi);

c45 = 0; c46 =  522586/(3465*pi); c47 = 0; c48 = 6279946/(45045*pi); c49 = 0; c410 = 6078482/(45045*pi);
c411 = 0; c412 = 101612746/(765765*pi); c413 = 0; c414 = 273105626/(2078505*pi); c415 = 0;

c56 = 0; c57 = 316034/(1287*pi); c58 = 0; c59 = 3360002/(15015*pi); c510 = 0; c511 = 14959778/(69615*pi);
c512 = 0; c513 = 5230034/(24871*pi); c514 = 0; c515 = 603979594/(2909907*pi);

c67 = 0; c68 = 84646/(231*pi); c69 = 0; c610 = 84334622/(255255*pi); c611 = 0; 
c612 = 509569542/(1616615*pi); c613 = 0; c614 = 4468589038/(14549535*pi); c615 = 0; 

c78 = 0; c79 = 18766718/(36465*pi); c710 = 0; c711 = 86968666/(188955*pi); c712 = 0; 
c713 = 488766202/(1119195*pi); c714 = 0; c715 = 28371838102/(66927861*pi);

c89 =  0; c810 = 2011510750/(2909907*pi); c811 = 0; c812 = 2979119498/(4849845*pi); c813 = 0; 
c814 = 194146451834/(334639305*pi); c815 =  0;

c910 = 0; c911 = 56510302/(62985*pi); c912 = 0; c913 = 6806304914/(8580495*pi); c914 = 0;
c915 = 138739737142/(185910725*pi);

c1011 = 0; c1012 = 3611886922/(3187041*pi); c1013 = 0; c1014 = 238519767494/(239028075*pi);
c1015 = 0;

c1112 = 0; c1113 = 16384742746/(11700675*pi); c1114 = 0; c1115 = 560769198566/(456326325*pi);

c1213 = 0; c1214 = 1218294116554/(717084225*pi); c1215 = 0;

c1314 = 0; c1315 = 4545831001658/(2239509195*pi);

c1415 =  0; 

/* symmetric matrix of coefficients c_{ii} and c_{ij} */

c_vec_15 = 
c00|
c01|c11|
c02|c12|c22|
c03|c13|c23|c33|
c04|c14|c24|c34|c44|
c05|c15|c25|c35|c45|c55|
c06|c16|c26|c36|c46|c56|c66|
c07|c17|c27|c37|c47|c57|c67|c77|
c08|c18|c28|c38|c48|c58|c68|c78|c88|
c09|c19|c29|c39|c49|c59|c69|c79|c89|c99|
c010|c110|c210|c310|c410|c510|c610|c710|c810|c910|c1010|
c011|c111|c211|c311|c411|c511|c611|c711|c811|c911|c1011|c1111|
c012|c112|c212|c312|c412|c512|c612|c712|c812|c912|c1012|c1112|c1212|
c013|c113|c213|c313|c413|c513|c613|c713|c813|c913|c1013|c1113|c1213|c1313|
c014|c114|c214|c314|c414|c514|c614|c714|c814|c914|c1014|c1114|c1214|c1314|c1414|
c015|c115|c215|c315|c415|c515|c615|c715|c815|c915|c1015|c1115|c1215|c1315|c1415|c1515;

D_matrix = xpnd(c_vec_15);

D_inv = invpd(D_matrix);

/* computations of L2 norm */

/* coefficients d_{ii} of theta_i^2 of the quadratic form in theta */

d00 = 1/(pi); d11 = 2/(3*pi); d22 = 14/(15*pi); d33 = 34/(35*pi); d44 = 62/(63*pi);
d55 = 98/(99*pi); d66 = 142/(143*pi); d77 = 194/(195*pi); d88 = 254/(255*pi);
d99 = 322/(323*pi); d1010 = 398/(399*pi); d1111 = 482/(483*pi);
d1212 = 574/(575*pi); d1313 = 674/(675*pi); d1414 = 782/(783*pi); d1515 = 898/(899*pi);

/* coefficients d_{ij} of 2 theta_i theta_j , i \neq j, of the quadratic form in theta */

d01 = 0; d02 = -1/(3*pi)*sqrt(2); d03 = 0; d04 = -1/(15*pi)*sqrt(2); d05 = 0;
d06 = -1/(35*pi)*sqrt(2); d07 = 0; d08 = -1/(63*pi)*sqrt(2); d09 = 0; d010 = -1/(99*pi)*sqrt(2);
d011 = 0; d012 = -1/(143*pi)*sqrt(2); d013 = 0; d014 = -1/(195*pi)*sqrt(2); d015 = 0;

d12 = 0; d13 = -2/(5*pi); d14 = 0; d15 = -2/(21*pi); d16 = 0; d17 = -2/(45*pi); d18 = 0; 
d19 = -2/(77*pi); d110 = 0; d111 = -2/(117*pi); d112 = 0; d113 = -2/(165*pi); d114 = 0;
d115 = -2/(221*pi);

d23 = 0; d24 = -38/(105*pi); d25 = 0; d26 = -26/(315*pi); d27 = 0; d28 = -134/(3465*pi);
d29 = 0; d210 = -206/(9009*pi); d211 = 0; d212 = -98/(6435*pi); d213= 0; 
d214 = -398/(36465*pi); d215 = 0;

d34 = 0; d35 = -22/(63*pi); d36 = 0; d37 = -38/(495*pi); d38 = 0; d39 = -178/(5005*pi);
d310 = 0; d311 = -86/(4095*pi); d312 = 0; d313 = -118/(8415*pi); d314 = 0; d315 = -466/(46189*pi);

d45 = 0; d46 = -34/(99*pi); d47 = 0; d48 = -158/(2145*pi); d49 = 0; d410 = -46/(1365*pi);
d411= 0; d412 = -106/(5355*pi); d413 = 0; d414 = -422/(31977*pi); d415 = 0;

d56 = 0; d57 = -146/(429*pi); d58 = 0; d59 = -14/(195*pi); d510 = 0; d511 = -58/(1785*pi);
d512= 0; d513 = -386/(20349*pi); d514 = 0; d515 = -166/(13167*pi);

d67 = 0; d68 = -22/(65*pi); d69 = 0; d610 = -6/(85*pi); d611 = 0; d612 = -358/(11305*pi);
d613 = 0; d614 = -22/(1197*pi); d615 = 0;

d78 = 0; d79 = -86/(255*pi); d710 = 0; d711 = -338/(4845*pi); d712 = 0; d713 = -62/(1995*pi);
d714 = 0; d715 = -26/(1449*pi);

d89 = 0; d810 = -326/(969*pi); d811= 0; d812 = -46/(665*pi); d813 = 0; d814 = -74/(2415*pi);
d815= 0;

d910 = 0; d911 = -134/(399*pi); d912 = 0; d913 = -166/(2415*pi); d914 = 0; d915 = -122/(4025*pi);

d1011 = 0; d1012 = -54/(161*pi); d1013 = 0; d1014 = -118/(1725*pi); d1015 = 0;

d1112 = 0; d1113 = -578/(1725*pi); d1114 = 0; d1115 = -46/(675*pi);

d1213 = 0; d1214= -226/(675*pi); d1215= 0;

d1314 = 0; d1315 = -262/(783*pi);

d1415= 0;

/* symmetric matrix of coefficients d_{ii} and d_{ij} */

d_vec_15 = 
d00|
d01|d11|
d02|d12|d22|
d03|d13|d23|d33|
d04|d14|d24|d34|d44|
d05|d15|d25|d35|d45|d55|
d06|d16|d26|d36|d46|d56|d66|
d07|d17|d27|d37|d47|d57|d67|d77|
d08|d18|d28|d38|d48|d58|d68|d78|d88|
d09|d19|d29|d39|d49|d59|d69|d79|d89|d99|
d010|d110|d210|d310|d410|d510|d610|d710|d810|d910|d1010|
d011|d111|d211|d311|d411|d511|d611|d711|d811|d911|d1011|d1111|
d012|d112|d212|d312|d412|d512|d612|d712|d812|d912|d1012|d1112|d1212|
d013|d113|d213|d313|d413|d513|d613|d713|d813|d913|d1013|d1113|d1213|d1313|
d014|d114|d214|d314|d414|d514|d614|d714|d814|d914|d1014|d1114|d1214|d1314|d1414|
d015|d115|d215|d315|d415|d515|d615|d715|d815|d915|d1015|d1115|d1215|d1315|d1415|d1515;

B_matrix = xpnd(d_vec_15);

/* bandwidth for y */

hy = 1.06*stdc(obs[.,1])*T^(-1/5);

/* bandwidth for x */

hx = 1.06*stdc(obs[.,2])*T^(-1/5);

/* bandwidth for z */

hz = 1.06*stdc(obs[.,3])*T^(-1/5);

bandw = hz;

/* First step estimator */

/* shifted Chebyshev polynomial of the first kind of order 0 */ 

phi0 = 1./sqrt(pi).*ones(T,1);

/* shifted Chebyshev polynomial of the first kind of order 1 */ 

phi1 = (-1+2.*obs[.,2])./sqrt(pi/2);

/* shifted Chebyshev polynomial of the first kind of order 2 */ 

phi2 = (1-8.*obs[.,2]+8.*obs[.,2]^2)./sqrt(pi/2);

/* shifted Chebyshev polynomial of the first kind of order 3 */ 

phi3 = (-1+18.*obs[.,2]-48.*obs[.,2]^2+32.*obs[.,2]^3)./sqrt(pi/2);

/* shifted Chebyshev polynomial of the first kind of order 4 */ 

phi4 = (1-32.*obs[.,2]+160.*obs[.,2]^2-256.*obs[.,2]^3+128.*obs[.,2]^4)./sqrt(pi/2);

/* shifted Chebyshev polynomial of the first kind of order 5 */ 

phi5 = (-1+50.*obs[.,2]-400.*obs[.,2]^2+1120.*obs[.,2]^3-1280.*obs[.,2]^4+512.*obs[.,2]^5)./sqrt(pi/2);

/* shifted Chebyshev polynomial of the first kind of order 6 */ 

phi6 = (1-72.*obs[.,2]+840.*obs[.,2]^2-3584.*obs[.,2]^3+6912.*obs[.,2]^4-6144.*obs[.,2]^5+2048.*obs[.,2]^6)./sqrt(pi/2);

/* shifted Chebyshev polynomial of the first kind of order 7 */ 

phi7 = (-1+98.*obs[.,2]-1568.*obs[.,2]^2+9408.*obs[.,2]^3-26880.*obs[.,2]^4+39424.*obs[.,2]^5-28672.*obs[.,2]^6+8192.*obs[.,2]^7)./sqrt(pi/2);

/* shifted Chebyshev polynomial of the first kind of order 8 */ 

phi8 = (1-128.*obs[.,2]+2688.*obs[.,2]^2-21504.*obs[.,2]^3+84480.*obs[.,2]^4-180224.*obs[.,2]^5+212992.*obs[.,2]^6-131072.*obs[.,2]^7+32768.*obs[.,2]^8)./sqrt(pi/2);

/* shifted Chebyshev polynomial of the first kind of order 9 */ 

phi9 = (-1+162.*obs[.,2]-4320.*obs[.,2]^2+44352.*obs[.,2]^3-228096.*obs[.,2]^4+658944.*obs[.,2]^5-1118208.*obs[.,2]^6+1105920.*obs[.,2]^7-589824.*obs[.,2]^8+131072.*obs[.,2]^9)./sqrt(pi/2);

/* shifted Chebyshev polynomial of the first kind of order 10 */ 

phi10 = (1-200.*obs[.,2]+6600.*obs[.,2]^2-84480.*obs[.,2]^3+549120.*obs[.,2]^4-2050048.*obs[.,2]^5+4659200.*obs[.,2]^6-6553600.*obs[.,2]^7+5570560.*obs[.,2]^8  
-2621440.*obs[.,2]^9+524288.*obs[.,2]^10)./sqrt(pi/2);

/* shifted Chebyshev polynomial of the first kind of order 11 */ 

phi11 = (-1+242.*obs[.,2]-9680.*obs[.,2]^2+151008.*obs[.,2]^3-1208064.*obs[.,2]^4+5637632.*obs[.,2]^5-16400384.*obs[.,2]^6+30638080.*obs[.,2]^7-36765696.*obs[.,2]^8  
+27394048.*obs[.,2]^9-11534336.*obs[.,2]^10+2097152.*obs[.,2]^11)./sqrt(pi/2);

/* shifted Chebyshev polynomial of the first kind of order 12 */ 

phi12 = (1-288.*obs[.,2]+13728.*obs[.,2]^2-256256.*obs[.,2]^3+2471040.*obs[.,2]^4-14057472.*obs[.,2]^5+50692096.*obs[.,2]^6-120324096.*obs[.,2]^7+190513152.*obs[.,2]^8  
-199229440.*obs[.,2]^9+132120576.*obs[.,2]^10-50331648.*obs[.,2]^11+8388608.*obs[.,2]^12)./sqrt(pi/2);

/* shifted Chebyshev polynomial of the first kind of order 13 */ 

phi13 = (-1+338.*obs[.,2]-18928.*obs[.,2]^2+416416.*obs[.,2]^3-4759040.*obs[.,2]^4+32361472.*obs[.,2]^5-141213696.*obs[.,2]^6+412778496.*obs[.,2]^7-825556992 
.*obs[.,2]^8+1133117440.*obs[.,2]^9-1049624576.*obs[.,2]^10+627048448.*obs[.,2]^11-218103808.*obs[.,2]^12+33554432.*obs[.,2]^13)./sqrt(pi/2);

/* shifted Chebyshev polynomial of the first kind of order 14 */ 

phi14 = (1-392.*obs[.,2]+25480.*obs[.,2]^2-652288.*obs[.,2]^3+8712704.*obs[.,2]^4-69701632.*obs[.,2]^5+361181184.*obs[.,2]^6-1270087680.*obs[.,2]^7+3111714816.*obs[.,2]^8
-5369233408.*obs[.,2]^9+6499598336.*obs[.,2]^10-5402263552.*obs[.,2]^11+2936012800.*obs[.,2]^12-939524096.*obs[.,2]^13+134217728.*obs[.,2]^14)./sqrt(pi/2);

/* shifted Chebyshev polynomial of the first kind of order 15 */ 

phi15 = (-1+450.*obs[.,2]-33600.*obs[.,2]^2+990080.*obs[.,2]^3-15275520.*obs[.,2]^4+141892608.*obs[.,2]^5-859955200.*obs[.,2]^6+3572121600.*obs[.,2]^7-  
10478223360.*obs[.,2]^8+22052208640.*obs[.,2]^9-33426505728.*obs[.,2]^10+36175872000.*obs[.,2]^11-27262976000.*obs[.,2]^12+13589544960.*obs[.,2]^13- 
4026531840.*obs[.,2]^14+536870912.*obs[.,2]^15)./sqrt(pi/2);


/* estimation of density of Z : denominator of nonparametric regression curve */

densi = dens(z);

/* estimation of r_hat */

vec_r = sumc(obs[.,1].*pdfn((obs[.,3]-(ones(T,1).*.obs[.,3]'))/bandw));

r_hat = vec_r./densi;

/* estimation of P_hat */

/* vector of numerator in regression curves */

vec_phi0 = sumc(phi0.*pdfn((obs[.,3]-(ones(T,1).*.obs[.,3]'))/bandw));
vec_phi1 = sumc(phi1.*pdfn((obs[.,3]-(ones(T,1).*.obs[.,3]'))/bandw));
vec_phi2 = sumc(phi2.*pdfn((obs[.,3]-(ones(T,1).*.obs[.,3]'))/bandw));
vec_phi3 = sumc(phi3.*pdfn((obs[.,3]-(ones(T,1).*.obs[.,3]'))/bandw));
vec_phi4 = sumc(phi4.*pdfn((obs[.,3]-(ones(T,1).*.obs[.,3]'))/bandw));
vec_phi5 = sumc(phi5.*pdfn((obs[.,3]-(ones(T,1).*.obs[.,3]'))/bandw));
vec_phi6 = sumc(phi6.*pdfn((obs[.,3]-(ones(T,1).*.obs[.,3]'))/bandw));
vec_phi7 = sumc(phi7.*pdfn((obs[.,3]-(ones(T,1).*.obs[.,3]'))/bandw));
vec_phi8 = sumc(phi8.*pdfn((obs[.,3]-(ones(T,1).*.obs[.,3]'))/bandw));
vec_phi9 = sumc(phi9.*pdfn((obs[.,3]-(ones(T,1).*.obs[.,3]'))/bandw));
vec_phi10 = sumc(phi10.*pdfn((obs[.,3]-(ones(T,1).*.obs[.,3]'))/bandw));
vec_phi11 = sumc(phi11.*pdfn((obs[.,3]-(ones(T,1).*.obs[.,3]'))/bandw));
vec_phi12 = sumc(phi12.*pdfn((obs[.,3]-(ones(T,1).*.obs[.,3]'))/bandw));
vec_phi13 = sumc(phi13.*pdfn((obs[.,3]-(ones(T,1).*.obs[.,3]'))/bandw));
vec_phi14 = sumc(phi14.*pdfn((obs[.,3]-(ones(T,1).*.obs[.,3]'))/bandw));
vec_phi15 = sumc(phi15.*pdfn((obs[.,3]-(ones(T,1).*.obs[.,3]'))/bandw));

/* estimation of P_hat */

P_hat_reg = (vec_phi0~vec_phi1~vec_phi2~vec_phi3~vec_phi4~vec_phi5~vec_phi6~vec_phi7~vec_phi8~vec_phi9~vec_phi10~vec_phi11~vec_phi12~vec_phi13~vec_phi14~vec_phi15)./densi;

/* computation of estimated theta with pilot parameter */

theta_tilde = inv(p_lambda*D_matrix + P_hat_reg'P_hat_reg/T)*P_hat_reg'r_hat/T;

/* Computation of conditional variance */

/* estimation of second moment */

vec_sto_mom2 = (obs[.,1] - phi0.*theta_tilde[1] - phi1.*theta_tilde[2] - phi2.*theta_tilde[3] - phi3.*theta_tilde[4]
- phi4.*theta_tilde[5] - phi5.*theta_tilde[6]- phi6.*theta_tilde[7] - phi7.*theta_tilde[8]- phi8.*theta_tilde[9] - phi9.*theta_tilde[10]- phi10.*theta_tilde[11]- phi11.*theta_tilde[12] - phi12.*theta_tilde[13]- phi13.*theta_tilde[14]- phi14.*theta_tilde[15] - phi15.*theta_tilde[16])^2; 

vec_mom2 = sumc(vec_sto_mom2.*pdfn((obs[.,3]-(ones(T,1).*.obs[.,3]'))/bandw));

mom2_hat = vec_mom2./densi;

/* estimation of first moment */

vec_sto_mom1 = (obs[.,1] - phi0.*theta_tilde[1] - phi1.*theta_tilde[2] - phi2.*theta_tilde[3] - phi3.*theta_tilde[4]
- phi4.*theta_tilde[5] - phi5.*theta_tilde[6]- phi6.*theta_tilde[7] - phi7.*theta_tilde[8]- phi8.*theta_tilde[9]- phi9.*theta_tilde[10]- phi10.*theta_tilde[11]-phi11.*theta_tilde[12]-phi12.*theta_tilde[12]-phi13.*theta_tilde[14]-phi14.*theta_tilde[15]-phi15.*theta_tilde[16]); 

vec_mom1 = sumc(vec_sto_mom1.*pdfn((obs[.,3]-(ones(T,1).*.obs[.,3]'))/bandw));

mom1_hat = vec_mom1./densi;

/* estimated conditional variance */

vari_est = mom2_hat - (mom1_hat)^2; 

/* estimation of r_hat weighted */

r_hat_weight = r_hat./sqrt(vari_est);

/* estimation of P_hat weighted*/

P_hat_weight = P_hat_reg./sqrt(vari_est);

/* computation of estimated theta with pilot parameter and weight*/

theta_tilde_weight = inv(p_lambda*D_matrix + P_hat_weight'P_hat_weight/T)*P_hat_weight'r_hat_weight/T;

/* Spectral decomposition */

alpha_tilde = P_hat_weight'P_hat_weight/T;

N = D_inv*alpha_tilde;

{nu,w}=eigv(N);

w = w./sqrt( diag(w'D_matrix*w) )';

norm_squared_psi = zeros(16,1);

i=1;
do until i> 16;
  norm_squared_psi[i] = w[.,i]'B_matrix*w[.,i] ;
  i=i+1;
endo;

/* Initializing vectors to stock results */

vari_grid = zeros(grid_size,1);
bias_grid = zeros(grid_size,1);
MISE_grid = zeros(grid_size,1);

/* starting the loop on grid */

for l(1,grid_size,1);

lambda = grid_lambda[l];

/* variance term */

   vari =0;
    i=1;
    do until i>16;
        vari = vari + nu[i]*norm_squared_psi[i]./ (lambda + nu[i] )^2;
        i=i+1;
  endo;
 
vari_grid[l] = vari/T;

/* bias term */

    A_matrix=invpd( alpha_tilde + lambda*D_matrix );
    A_matrix= A_matrix*alpha_tilde - eye(16);
    bias=theta_tilde_weight'A_matrix'B_matrix*A_matrix*theta_tilde_weight;
    
bias_grid[l] = bias;

/* Computation of spectral MISE */

MISE_grid[l] =  vari_grid[l] + bias_grid[l];

endfor;

/* Optimal spectral MISE and Lambda */

MISE_opt = minc(MISE_grid);

lambda_opt = sumc(grid_lambda.*(MISE_grid .eq (MISE_opt))); 

theta_est = inv(lambda_opt*D_matrix + P_hat_weight'P_hat_weight/T)*P_hat_weight'r_hat_weight/T;

/* Numerical integration for Frechet derivative : rectangle method */

step_x = (1-2.*0.000001)/(100-1);
x_grid = seqa(0.000001,step_x,100);

/* Computation of pilot estimate */

/* starting values for theta : NIV regression estimates */

start_theta = theta_est;

/* computation of estimated theta  for tau_1*/

tau = tau_1;

lambda = p_lambda;

/* estimation of theta */

_opgdprc = &grad_crit;
_ophsprc = &hess_crit;
_opmiter = 150;
__output=0; 
{theta_est, f,g,retcode} = optmum(&crit, start_theta);

if retcode .eq 0;
theta_est = theta_est;
else;
theta_est = start_theta;
endif;

theta_tilde = theta_est;

/* estimation of P_hat_Frechet */

P_hat_Frechet = zeros(T,16);

for i(1,rows(x_grid),1);

xg = x_grid[i];

poly = poly0(1)~poly1(xg)~poly2(xg)~poly3(xg)~poly4(xg)~poly5(xg)~poly6(xg)~poly7(xg)~poly8(xg)~poly9(xg)~poly10(xg)~poly11(xg)~poly12(xg)~poly13(xg)~poly14(xg)~poly15(xg);

phi_bar = poly*theta_tilde;

P_sto = poly.*(1/hx/hy).*sumc(pdfn((obs[.,1]-phi_bar)/hy).*pdfn((obs[.,2]-xg)/hx).*pdfn((obs[.,3]-(ones(T,1).*.obs[.,3]'))/hz));

P_hat_Frechet = P_hat_Frechet + P_sto;

endfor;

P_hat_Frechet = step_x.*P_hat_Frechet./dens(obs[.,3])/sqrt(tau*(1-tau));

/* Spectral decomposition */

alpha_tilde = P_hat_Frechet'P_hat_Frechet/T;

N = D_inv*alpha_tilde;

{nu,w}=eigv(N);

w = w./sqrt( diag(w'D_matrix*w) )';

norm_squared_psi = zeros(16,1);

i=1;
do until i> 16;
  norm_squared_psi[i] = w[.,i]'B_matrix*w[.,i] ;
  i=i+1;
endo;

/* starting the loop on grid */

for l(1,grid_size,1);

lambda = grid_lambda[l];

/* variance term */

   vari =0;
    i=1;
    do until i>16;
        vari = vari + nu[i]*norm_squared_psi[i]./ (lambda + nu[i] )^2;
        i=i+1;
  endo;
 
vari_grid[l] = vari/T;

/* bias term */

    A_matrix=invpd( alpha_tilde + lambda*D_matrix );
    A_matrix= A_matrix*alpha_tilde - eye(16);
    bias=theta_tilde'A_matrix'B_matrix*A_matrix*theta_tilde;
    
bias_grid[l] = bias;

/* Computation of spectral MISE */

MISE_grid[l] =  vari_grid[l] + bias_grid[l];

endfor;

/* Optimal spectral MISE and Lambda */

MISE_opt = minc(MISE_grid);

lambda_opt = sumc(grid_lambda.*(MISE_grid .eq (MISE_opt))); 

/* computation of estimated theta with smaller regularization parameter*/

lambda = lambda_opt .* red_fac;

/* estimation of theta */

_opgdprc = &grad_crit;
_ophsprc = &hess_crit;
_opmiter = 150;
__output=0;
{theta_est, f,g,retcode} = optmum(&crit, theta_tilde);

if retcode .eq 0;
theta_est = theta_est;
else;
theta_est = theta_tilde;
endif;

/* Computation of estimated  function */

/* grid on [0,1] */

xx = seqa(0.01,.01,99);
xxx = cdfni(xx);

/* xxx = (cdfni(xx).*st_xstar)+ave_xstar; */
/*
xxx = seqa(6.5,.05,(12.5-6.5)/.05+1);
xx = cdfn((xxx-ave_xstar)/st_xstar);
*/

/* shifted Chebyshev polynomial of the first kind of order 0 */ 

phi0 = 1./sqrt(pi);

/* shifted Chebyshev polynomial of the first kind of order 1 */ 

phi1 = (-1+2.*xx)./sqrt(pi/2);

/* shifted Chebyshev polynomial of the first kind of order 2 */ 

phi2 = (1-8.*xx+8.*xx^2)./sqrt(pi/2);

/* shifted Chebyshev polynomial of the first kind of order 3 */ 

phi3 = (-1+18.*xx-48.*xx^2+32.*xx^3)./sqrt(pi/2);

/* shifted Chebyshev polynomial of the first kind of order 4 */ 

phi4 = (1-32.*xx+160.*xx^2-256.*xx^3+128.*xx^4)./sqrt(pi/2);

/* shifted Chebyshev polynomial of the first kind of order 5 */ 

phi5 = (-1+50.*xx-400.*xx^2+1120.*xx^3-1280.*xx^4+512.*xx^5)./sqrt(pi/2);

/* shifted Chebyshev polynomial of the first kind of order 6 */ 

phi6 = (1-72.*xx+840.*xx^2-3584.*xx^3+6912.*xx^4-6144.*xx^5+2048.*xx^6)./sqrt(pi/2);

/* shifted Chebyshev polynomial of the first kind of order 7 */ 

phi7 = (-1+98.*xx-1568.*xx^2+9408.*xx^3-26880.*xx^4+39424.*xx^5-28672.*xx^6+8192.*xx^7)./sqrt(pi/2);

/* shifted Chebyshev polynomial of the first kind of order 8 */ 

phi8 = (1-128.*xx+2688.*xx^2-21504.*xx^3+84480.*xx^4-180224.*xx^5+212992.*xx^6-131072.*xx^7+32768.*xx^8)./sqrt(pi/2);

/* shifted Chebyshev polynomial of the first kind of order 9 */ 

phi9 = (-1+162.*xx-4320.*xx^2+44352.*xx^3-228096.*xx^4+658944.*xx^5-1118208.*xx^6+1105920.*xx^7-589824.*xx^8+131072.*xx^9)./sqrt(pi/2);

/* shifted Chebyshev polynomial of the first kind of order 10 */ 

phi10 = (1-200.*xx+6600.*xx^2-84480.*xx^3+549120.*xx^4-2050048.*xx^5+4659200.*xx^6-6553600.*xx^7+5570560.*xx^8  
-2621440.*xx^9+524288.*xx^10)./sqrt(pi/2);

/* shifted Chebyshev polynomial of the first kind of order 11 */ 

phi11 = (-1+242.*xx-9680.*xx^2+151008.*xx^3-1208064.*xx^4+5637632.*xx^5-16400384.*xx^6+30638080.*xx^7-36765696.*xx^8  
+27394048.*xx^9-11534336.*xx^10+2097152.*xx^11)./sqrt(pi/2);

/* shifted Chebyshev polynomial of the first kind of order 12 */ 

phi12 = (1-288.*xx+13728.*xx^2-256256.*xx^3+2471040.*xx^4-14057472.*xx^5+50692096.*xx^6-120324096.*xx^7+190513152.*xx^8  
-199229440.*xx^9+132120576.*xx^10-50331648.*xx^11+8388608.*xx^12)./sqrt(pi/2);

/* shifted Chebyshev polynomial of the first kind of order 13 */ 

phi13 = (-1+338.*xx-18928.*xx^2+416416.*xx^3-4759040.*xx^4+32361472.*xx^5-141213696.*xx^6+412778496.*xx^7-825556992 
.*xx^8+1133117440.*xx^9-1049624576.*xx^10+627048448.*xx^11-218103808.*xx^12+33554432.*xx^13)./sqrt(pi/2);

/* shifted Chebyshev polynomial of the first kind of order 14 */ 

phi14 = (1-392.*xx+25480.*xx^2-652288.*xx^3+8712704.*xx^4-69701632.*xx^5+361181184.*xx^6-1270087680.*xx^7+3111714816.*xx^8
-5369233408.*xx^9+6499598336.*xx^10-5402263552.*xx^11+2936012800.*xx^12-939524096.*xx^13+134217728.*xx^14)./sqrt(pi/2);

/* shifted Chebyshev polynomial of the first kind of order 15 */ 

phi15 = (-1+450.*xx-33600.*xx^2+990080.*xx^3-15275520.*xx^4+141892608.*xx^5-859955200.*xx^6+3572121600.*xx^7-  
10478223360.*xx^8+22052208640.*xx^9-33426505728.*xx^10+36175872000.*xx^11-27262976000.*xx^12+13589544960.*xx^13- 
4026531840.*xx^14+536870912.*xx^15)./sqrt(pi/2);

/* estimated function*/

y_est_1 = phi0.*theta_est[1] + phi1.*theta_est[2] + phi2.*theta_est[3] + phi3.*theta_est[4]
+ phi4.*theta_est[5] + phi5.*theta_est[6] + phi6.*theta_est[7]+ phi7.*theta_est[8]+ phi8.*theta_est[9]+ phi9.*theta_est[10]+ phi10.*theta_est[11] + phi11.*theta_est[12]+ phi12.*theta_est[13]+ phi13.*theta_est[14]+ phi14.*theta_est[15]+ phi15.*theta_est[16]; 

/* estimated variance */

poly_vec = (phi0.*ones(rows(xx),1))~phi1~phi2~phi3~phi4~phi5~phi6~phi7~phi8~phi9~phi10~phi11~phi12~phi13~phi14~phi15;

 vari =0;
    i=1;
    do until i>n_t;
        vari = vari + nu[i]./ (lambda + nu[i] )^2.*(poly_vec*w[.,i]).*poly_vec*w[.,i];
        i=i+1;
  endo;

vari = vari/T;

eststd = sqrt(vari);

/* Upper IC bound  */

IC_up_1 = y_est_1 + cdfni(prob_up).*eststd;

/* Lower IC bound  */

IC_low_1 = y_est_1 + cdfni(prob_low).*eststd;

/* drawing the graph */

graphset;
/* format /rdn 8,2; */
_pdate = "";
title("Median structural effect and pointwise CI"); 
begwind;
window(1,2,0);
_plwidth = 15;
/*_pcolor = 2;*/
xlabel("x");
ylabel("estimated functions .50");
xy(xx,y_est_1~IC_up_1~IC_low_1);
nextwind;
xlabel("xstar");
ylabel("estimated functions .50");
xy(xxx,y_est_1~IC_up_1~IC_low_1);
endwind;

print "end time" time;
time_end = time;
output off; 

/* output file results */

output on;
output file= "C:\Documents and Settings\OScaillet\Mes documents\gausspgm\data_Hausman\QTiR_estimation\Normality_QTiR_HS\fig_normality_HS_poor_15_80_4.out" reset;
print "x in [0,1]";
xx;
print "xstar in R";
xxx;
print "estimated functions .50";
y_est_1;
print "estimated upper bound .50";
IC_up_1;
print "estimated lower bound .50";
IC_low_1;
output off;

format /rdn 8,5;

output on;
output file= "C:\Documents and Settings\OScaillet\Mes documents\gausspgm\data_Hausman\QTiR_estimation\Normality_QTiR_HS\normality_HS_poor_15_80_4.out" reset;
print "linear case: sobolev norm";
print "closed form";
print "Sample size";
print"tau_1";
tau_1;
print "sample size";
T;
print "lambda opt";
lambda_opt;
print "reduction factor for IC";
red_fac;
print "reduced lambda";
lambda;
print "truncation term";
n_t;
print "Starting time";
time_start;
print "end time";
time_end;
output off;

closeall;
end;

/* PROCEDURES */

/* COMPUTATIONS OF CHEBYSHEV POLYNOMIALS */ 

/* shifted Chebyshev polynomial of the first kind of order 0 */ 

proc poly0(x);
retp(1./sqrt(pi).*x);
endp;

/* shifted Chebyshev polynomial of the first kind of order 1 */ 

proc poly1(x);
retp((-1+2.*x)./sqrt(pi/2));
endp;

/* shifted Chebyshev polynomial of the first kind of order 2 */ 

proc poly2(x);
retp((1-8.*x+8.*x^2)./sqrt(pi/2));
endp;

/* shifted Chebyshev polynomial of the first kind of order 3 */ 

proc poly3(x);
retp((-1+18.*x-48.*x^2+32.*x^3)./sqrt(pi/2));
endp;

/* shifted Chebyshev polynomial of the first kind of order 4 */ 

proc poly4(x);
retp((1-32.*x+160.*x^2-256.*x^3+128.*x^4)./sqrt(pi/2));
endp;

/* shifted Chebyshev polynomial of the first kind of order 5 */ 

proc poly5(x);
retp((-1+50.*x-400.*x^2+1120.*x^3-1280.*x^4+512.*x^5)./sqrt(pi/2));
endp;

/* shifted Chebyshev polynomial of the first kind of order 6 */ 

proc poly6(x);
retp((1-72.*x+840.*x^2-3584.*x^3+6912.*x^4-6144.*x^5+2048.*x^6)./sqrt(pi/2));
endp;

/* shifted Chebyshev polynomial of the first kind of order 7 */ 

proc poly7(x);
retp((-1+98.*x-1568.*x^2+9408.*x^3-26880.*x^4+39424.*x^5-28672.*x^6+8192.*x^7)./sqrt(pi/2));
endp;

/* shifted Chebyshev polynomial of the first kind of order 8 */ 

proc poly8(x);
retp((1-128.*x+2688.*x^2-21504.*x^3+84480.*x^4-180224.*x^5+212992.*x^6-131072.*x^7+32768.*x^8)./sqrt(pi/2));
endp;

/* shifted Chebyshev polynomial of the first kind of order 9 */ 

proc poly9(x);
retp((-1+162.*x-4320.*x^2+44352.*x^3-228096.*x^4+658944.*x^5-1118208.*x^6+1105920.*x^7-589824.*x^8+131072.*x^9)./sqrt(pi/2));
endp;

/* shifted Chebyshev polynomial of the first kind of order 10 */ 

proc poly10(x);
retp((1-200.*x+6600.*x^2-84480.*x^3+549120.*x^4-2050048.*x^5+4659200.*x^6-6553600.*x^7+5570560.*x^8  
-2621440.*x^9+524288.*x^10)./sqrt(pi/2));
endp;

/* shifted Chebyshev polynomial of the first kind of order 11 */ 

proc poly11(x);
retp((-1+242.*x-9680.*x^2+151008.*x^3-1208064.*x^4+5637632.*x^5-16400384.*x^6+30638080.*x^7-36765696.*x^8  
+27394048.*x^9-11534336.*x^10+2097152.*x^11)./sqrt(pi/2));
endp;

/* shifted Chebyshev polynomial of the first kind of order 12 */ 

proc poly12(x);
retp((1-288.*x+13728.*x^2-256256.*x^3+2471040.*x^4-14057472.*x^5+50692096.*x^6-120324096.*x^7+190513152.*x^8  
-199229440.*x^9+132120576.*x^10-50331648.*x^11+8388608.*x^12)./sqrt(pi/2));
endp;

/* shifted Chebyshev polynomial of the first kind of order 13 */ 

proc poly13(x);
retp((-1+338.*x-18928.*x^2+416416.*x^3-4759040.*x^4+32361472.*x^5-141213696.*x^6+412778496.*x^7-825556992 
.*x^8+1133117440.*x^9-1049624576.*x^10+627048448.*x^11-218103808.*x^12+33554432.*x^13)./sqrt(pi/2));
endp;

/* shifted Chebyshev polynomial of the first kind of order 14 */ 

proc poly14(x);
retp((1-392.*x+25480.*x^2-652288.*x^3+8712704.*x^4-69701632.*x^5+361181184.*x^6-1270087680.*x^7+3111714816.*x^8
-5369233408.*x^9+6499598336.*x^10-5402263552.*x^11+2936012800.*x^12-939524096.*x^13+134217728.*x^14)./sqrt(pi/2));
endp;

/* shifted Chebyshev polynomial of the first kind of order 15 */ 

proc poly15(x);
retp((-1+450.*x-33600.*x^2+990080.*x^3-15275520.*x^4+141892608.*x^5-859955200.*x^6+3572121600.*x^7-  
10478223360.*x^8+22052208640.*x^9-33426505728.*x^10+36175872000.*x^11-27262976000.*x^12+13589544960.*x^13- 
4026531840.*x^14+536870912.*x^15)./sqrt(pi/2));
endp;

/* COMPUTATIONS OF PENALIZED CRITERION */

/* penalized criterion : Q_T(theta) + lambda theta' D theta */

proc crit(theta);
local crit;
crit = (P_hat(theta,obs[.,1],obs[.,2],obs[.,3]) - tau)'(P_hat(theta,obs[.,1],obs[.,2],obs[.,3]) - tau)/T/(tau.*(1-tau)) + lambda.* theta'*D_matrix*theta;
retp(crit);
endp; 

/* estimation of density of Z : denominator of conditional density */

proc dens(z);
retp(sumc(pdfn((z-(ones(T,1).*.z'))/hz)));
endp;

/* T X 1 vector P hat  */

proc P_hat(theta,y,x,z);
local nume, deno, sto, poly;
poly = poly0(ones(T,1))~poly1(x)~poly2(x)~poly3(x)~poly4(x)~poly5(x)~poly6(x)~poly7(x)~poly8(x)~poly9(x)~poly10(x)~poly11(x)~poly12(x)~poly13(x)~poly14(x)~poly15(x);
sto = -(y-poly*theta)/hy;
nume = sumc(cdfn(sto).*pdfn((z-(ones(T,1).*.z'))/hz)); 
deno = dens(z);
retp(nume./deno);
endp;

/* T X k vector gradient of P hat  */

proc grad_P_hat(theta,y,x,z);
local grad_Phat, sto, poly, deno, nume0, grad0, nume1, grad1, nume2, grad2, nume3, grad3, nume4, grad4, nume5, grad5, 
nume6, grad6, nume7, grad7, nume8, grad8, nume9, grad9, nume10, grad10, nume11, grad11, nume12, grad12, nume13, grad13, nume14, grad14, nume15, grad15;
poly = poly0(ones(T,1))~poly1(x)~poly2(x)~poly3(x)~poly4(x)~poly5(x)~poly6(x)~poly7(x)~poly8(x)~poly9(x)~poly10(x)~poly11(x)~poly12(x)~poly13(x)~poly14(x)~poly15(x);
sto = -(y-poly*theta)/hy;
deno = dens(z);
nume0 = sumc(poly0(ones(T,1))/hy.*pdfn(sto).*pdfn((z-(ones(T,1).*.z'))/hz)); 
grad0 = nume0./deno;
nume1 = sumc(poly1(x)/hy.*pdfn(sto).*pdfn((z-(ones(T,1).*.z'))/hz)); 
grad1 = nume1./deno; 
nume2 = sumc(poly2(x)/hy.*pdfn(sto).*pdfn((z-(ones(T,1).*.z'))/hz)); 
grad2 = nume2./deno; 
nume3 = sumc(poly3(x)/hy.*pdfn(sto).*pdfn((z-(ones(T,1).*.z'))/hz)); 
grad3 = nume3./deno; 
nume4 = sumc(poly4(x)/hy.*pdfn(sto).*pdfn((z-(ones(T,1).*.z'))/hz)); 
grad4 = nume4./deno; 
nume5 = sumc(poly5(x)/hy.*pdfn(sto).*pdfn((z-(ones(T,1).*.z'))/hz)); 
grad5 = nume5./deno; 
nume6 = sumc(poly6(x)/hy.*pdfn(sto).*pdfn((z-(ones(T,1).*.z'))/hz)); 
grad6 = nume6./deno; 
nume7 = sumc(poly7(x)/hy.*pdfn(sto).*pdfn((z-(ones(T,1).*.z'))/hz)); 
grad7 = nume7./deno;
nume8 = sumc(poly8(x)/hy.*pdfn(sto).*pdfn((z-(ones(T,1).*.z'))/hz)); 
grad8 = nume8./deno; 
nume9 = sumc(poly9(x)/hy.*pdfn(sto).*pdfn((z-(ones(T,1).*.z'))/hz)); 
grad9 = nume9./deno; 
nume10 = sumc(poly10(x)/hy.*pdfn(sto).*pdfn((z-(ones(T,1).*.z'))/hz)); 
grad10 = nume10./deno; 
nume11 = sumc(poly11(x)/hy.*pdfn(sto).*pdfn((z-(ones(T,1).*.z'))/hz)); 
grad11 = nume11./deno; 
nume12 = sumc(poly12(x)/hy.*pdfn(sto).*pdfn((z-(ones(T,1).*.z'))/hz)); 
grad12 = nume12./deno; 
nume13 = sumc(poly13(x)/hy.*pdfn(sto).*pdfn((z-(ones(T,1).*.z'))/hz)); 
grad13 = nume13./deno; 
nume14 = sumc(poly14(x)/hy.*pdfn(sto).*pdfn((z-(ones(T,1).*.z'))/hz)); 
grad14 = nume14./deno; 
nume15 = sumc(poly15(x)/hy.*pdfn(sto).*pdfn((z-(ones(T,1).*.z'))/hz)); 
grad15 = nume15./deno; 
grad_Phat = grad0~grad1~grad2~grad3~grad4~grad5~grad6~grad7~grad8~grad9~grad10~grad11~grad12~grad13~grad14~grad15;
retp(grad_Phat);
endp;

/* 1 X k vector gradient of penalized criterion  */

proc grad_crit(theta);
local grd, grad;
grad = 2*grad_P_hat(theta,obs[.,1],obs[.,2],obs[.,3])'(P_hat(theta,obs[.,1],obs[.,2],obs[.,3]) - tau)/T/(tau.*(1-tau));
grd = grad + 2*lambda.*D_matrix*theta;
retp(grd');
endp;

/* T X (k (k+1)/2) vector gradient^2 and cross product of P hat  */

proc grad2_P_hat(theta,y,x,z);
local grad2_Phat, zz, sto, poly, deno, nume, grad;
poly = poly0(ones(T,1))~poly1(x)~poly2(x)~poly3(x)~poly4(x)~poly5(x)~poly6(x)~poly7(x)~poly8(x)~poly9(x)~poly10(x)~poly11(x)~poly12(x)~poly13(x)~poly14(x)~poly15(x);
zz = vech((eye(T).*.ones(16,16)).*(vecr(poly)*vecr(poly)'));
zz = delif(zz, zz.eq 0);
zz = reshape(zz,T,16*(16+1)/2);
sto = -(y-poly*theta)/hy;
deno = dens(z);
nume = sumc(zz/(hy^2).*(-sto).*pdfn(sto)*~pdfn((z-(ones(T,1).*.z'))/hz)); 
nume = reshape(nume,16*(16+1)/2,T)';
grad = nume./deno; 
grad2_Phat = grad;
retp(grad2_Phat);
endp;


/* k X k vector Hessian of penalized criterion  */

proc hess_crit(theta);
local hessian, sto1, sto2, sto3;
sto1 =  grad2_P_hat(theta,obs[.,1],obs[.,2],obs[.,3]);
sto2 = grad_P_hat(theta,obs[.,1],obs[.,2],obs[.,3]);
sto2 = vech((eye(T).*.ones(16,16)).*(vecr(sto2)*vecr(sto2)'));
sto2 = delif(sto2, sto2 .eq 0);
sto2 = reshape(sto2,T,16*(16+1)/2);
sto3 = 2.*sumc(sto1.*(P_hat(theta,obs[.,1],obs[.,2],obs[.,3])-tau)+sto2)/T/(tau.*(1-tau));
hessian = xpnd(sto3) + 2*lambda*D_matrix;
retp(hessian);
endp;








