/* Estimation of functional parameter g */
/* Data of HS */
/* Support of g : [0,1] */
/* Instrumental variable Z */
/* criterion: minimum distance criterion + lambda * Sobolev norm */
/* closed form solution */
/* Chebyshev polynomials of order 0 to 7*/
/* computation of optimal lambda with a spectral approach */
/* optimal weighting matrix */
/* File name : TiR_HS_7.prg */

new;
library pgraph;
#include pgraph.ext;

screen on;
print "Starting time" time;
time_start = time;

load ixdtechg[18620,1] = "C:\\Documents and Settings\\OScaillet\\Mes documents\\gausspgm\\data_Hausman\\ixdtechg.txt";
load ixdtemin[18620,1] = "C:\\Documents and Settings\\OScaillet\\Mes documents\\gausspgm\\data_Hausman\\ixdtemin.txt";

load agec[18620,1] = "C:\\Documents and Settings\\OScaillet\\Mes documents\\gausspgm\\data_Hausman\\agec.txt";
load incomec[18620,1] = "C:\\Documents and Settings\\OScaillet\\Mes documents\\gausspgm\\data_Hausman\\incomec.txt";

load edhhc[18620,1] = "C:\\Documents and Settings\\OScaillet\\Mes documents\\gausspgm\\data_Hausman\\edhhc.txt";

load att[18620,1] = "C:\\Documents and Settings\\OScaillet\\Mes documents\\gausspgm\\data_Hausman\\att.txt";
load mci[18620,1] = "C:\\Documents and Settings\\OScaillet\\Mes documents\\gausspgm\\data_Hausman\\mci.txt";
load sprint[18620,1] = "C:\\Documents and Settings\\OScaillet\\Mes documents\\gausspgm\\data_Hausman\\sprint.txt"; 


interlata = ixdtechg ./  ixdtemin;
lmins = ixdtemin;
lincomec = ln(incomec);

/* Y, X, Z */

/* selection of variables based on years of education, operator, age */

/* e = (interlata .gt 0) .and (edhhc .le 8) .and (att .gt 0) .and (agec .ge 35) .and (agec .le 65); */

/* e = (interlata .gt 0) .and (interlata .le 1) .and (edhhc .le 12) .and (mci .gt 0) .and (agec .ge 30) .and (agec .le 45); */

e = (interlata .gt 0) .and (interlata .le 1) .and (edhhc .le 12) .and (att .gt 0) .and (agec .ge 30) .and (agec .le 45);

/* mapping of standardized data of Ystar, Xstar, Zstar in [0,1] via N(0,1) cdf */

ystar = selif(interlata, e);
/* y = cdfn((ystar-meanc(ystar))/stdc(ystar)); */
y = ystar;

xstar = selif(lmins, e);
x = cdfn((xstar-meanc(xstar))/stdc(xstar));

zstar = selif(lincomec, e); 
z = cdfn((zstar-meanc(zstar))/stdc(zstar));

/* Observed data */

obs = y~x~z;

/* Sample size */

T = rows(obs);

/* pilot regularisation parameter */

p_lambda = 0.0001; 

/* Grid of Lagrange multiplier lambda */

grid_size = 2500;
low_lambda = 0.0001;
up_lambda = 0.1;

step = (up_lambda - low_lambda)/(grid_size-1);
grid_lambda = seqa(low_lambda, step, grid_size);

/* grid of sample sizes : warning should be integer */

low_sample = 500;
up_sample = 750;
grid_sample = 51;

step_sample = (up_sample - low_sample)/(grid_sample-1);
grid_sample_size = seqa(low_sample, step_sample, grid_sample);

/* vector of : j = 1,...,8 */

j_vec = {1,2,3,4,5,6,7,8};

/* computations of Sobolev norm */

/* coefficients c_{ii} of theta_i^2 of the quadratic form in theta */

c00 = 1/pi; c11 = 26/(3*pi); c22 = 218/(5*pi); c33 = 3898/(35*pi); c44 = 67894/(315*pi);
c55 = 82802/(231*pi); c66 = 2712298/(5005*pi); c77 = 4938266/(6435*pi); c88 = 158690690/(153153*pi);
c99 = 2181203602/(1616615*pi); c1010 = 4968962774/(2909907*pi); c1111 = 64253317834/(30421755*pi);
c1212 = 476573355722/(185910725*pi); c1313 = 1182462228154/(386122275*pi);
c1414 = 25020924278446/(6931814175*pi); c1515 = 84347110614902/(20056049013*pi);

/* coefficients c_{ij} of 2 theta_i theta_j , i \neq j, of the quadratic form in theta */

c01 = 0; c02 = -1/(3*pi)*sqrt(2); c03 = 0; c04 = -1/(15*pi)*sqrt(2); c05 = 0;
c06 = -1/(35*pi)*sqrt(2); c07 = 0; c08 = -1/(63*pi)*sqrt(2); c09 = 0;
c010 = -1/(99*pi)*sqrt(2); c011 = 0; c012 = -1/(143*pi)*sqrt(2); c013 = 0;
c014 = -1/(195*pi)*sqrt(2); c015 = 0;

c12 = 0; c13 = 38/(5*pi); c14 = 0; c15 = 166/(21*pi); c16 = 0; c17 = 358/(45*pi);
c18 = 0; c19 = 614/(77*pi); c110 = 0; c111 = 934/(117*pi); c112 = 0; c113 = 1318/(165*pi);
c114 = 0; c115 = 1766/(221*pi);

c23 = 0; c24 = 1182/(35*pi); c25 = 0; c26 = 10342/(315*pi); c27 = 0; c28 = 37502/(1155*pi);
c29 = 0; c210 = 8818/(273*pi); c211 = 0; c212 = 18842/(585*pi); c213 = 0; 
c214 = 390822/(12155*pi); c215 = 0;

c34 = 0; c35 = 5090/(63*pi); c36 = 0; c37 = 37714/(495*pi); c38 = 0; c39 = 372662/(5005*pi); c310 = 0;
c311 = 301474/(4095*pi); c312 = 0; c313 = 615554/(8415*pi); c314 = 0; c315 = 3365270/(46189*pi);

c45 = 0; c46 =  522586/(3465*pi); c47 = 0; c48 = 6279946/(45045*pi); c49 = 0; c410 = 6078482/(45045*pi);
c411 = 0; c412 = 101612746/(765765*pi); c413 = 0; c414 = 273105626/(2078505*pi); c415 = 0;

c56 = 0; c57 = 316034/(1287*pi); c58 = 0; c59 = 3360002/(15015*pi); c510 = 0; c511 = 14959778/(69615*pi);
c512 = 0; c513 = 5230034/(24871*pi); c514 = 0; c515 = 603979594/(2909907*pi);

c67 = 0; c68 = 84646/(231*pi); c69 = 0; c610 = 84334622/(255255*pi); c611 = 0; 
c612 = 509569542/(1616615*pi); c613 = 0; c614 = 4468589038/(14549535*pi); c615 = 0; 

c78 = 0; c79 = 18766718/(36465*pi); c710 = 0; c711 = 86968666/(188955*pi); c712 = 0; 
c713 = 488766202/(1119195*pi); c714 = 0; c715 = 28371838102/(66927861*pi);

c89 =  0; c810 = 2011510750/(2909907*pi); c811 = 0; c812 = 2979119498/(4849845*pi); c813 = 0; 
c814 = 194146451834/(334639305*pi); c815 =  0;

c910 = 0; c911 = 56510302/(62985*pi); c912 = 0; c913 = 6806304914/(8580495*pi); c914 = 0;
c915 = 138739737142/(185910725*pi);

c1011 = 0; c1012 = 3611886922/(3187041*pi); c1013 = 0; c1014 = 238519767494/(239028075*pi);
c1015 = 0;

c1112 = 0; c1113 = 16384742746/(11700675*pi); c1114 = 0; c1115 = 560769198566/(456326325*pi);

c1213 = 0; c1214 = 1218294116554/(717084225*pi); c1215 = 0;

c1314 = 0; c1315 = 4545831001658/(2239509195*pi);

c1415 =  0; 

/* symmetric matrix of coefficients c_{ii} and c_{ij} */

c_vec_7 = 
c00|
c01|c11|
c02|c12|c22|
c03|c13|c23|c33|
c04|c14|c24|c34|c44|
c05|c15|c25|c35|c45|c55|
c06|c16|c26|c36|c46|c56|c66|
c07|c17|c27|c37|c47|c57|c67|c77;

D_matrix = xpnd(c_vec_7);

D_inv = invpd(D_matrix);

/* computations of L2 norm */

/* coefficients d_{ii} of theta_i^2 of the quadratic form in theta */

d00 = 1/(pi); d11 = 2/(3*pi); d22 = 14/(15*pi); d33 = 34/(35*pi); d44 = 62/(63*pi);
d55 = 98/(99*pi); d66 = 142/(143*pi); d77 = 194/(195*pi); d88 = 254/(255*pi);
d99 = 322/(323*pi); d1010 = 398/(399*pi); d1111 = 482/(483*pi);
d1212 = 574/(575*pi); d1313 = 674/(675*pi); d1414 = 782/(783*pi); d1515 = 898/(899*pi);

/* coefficients d_{ij} of 2 theta_i theta_j , i \neq j, of the quadratic form in theta */

d01 = 0; d02 = -1/(3*pi)*sqrt(2); d03 = 0; d04 = -1/(15*pi)*sqrt(2); d05 = 0;
d06 = -1/(35*pi)*sqrt(2); d07 = 0; d08 = -1/(63*pi)*sqrt(2); d09 = 0; d010 = -1/(99*pi)*sqrt(2);
d011 = 0; d012 = -1/(143*pi)*sqrt(2); d013 = 0; d014 = -1/(195*pi)*sqrt(2); d015 = 0;

d12 = 0; d13 = -2/(5*pi); d14 = 0; d15 = -2/(21*pi); d16 = 0; d17 = -2/(45*pi); d18 = 0; 
d19 = -2/(77*pi); d110 = 0; d111 = -2/(117*pi); d112 = 0; d113 = -2/(165*pi); d114 = 0;
d115 = -2/(221*pi);

d23 = 0; d24 = -38/(105*pi); d25 = 0; d26 = -26/(315*pi); d27 = 0; d28 = -134/(3465*pi);
d29 = 0; d210 = -206/(9009*pi); d211 = 0; d212 = -98/(6435*pi); d213= 0; 
d214 = -398/(36465*pi); d215 = 0;

d34 = 0; d35 = -22/(63*pi); d36 = 0; d37 = -38/(495*pi); d38 = 0; d39 = -178/(5005*pi);
d310 = 0; d311 = -86/(4095*pi); d312 = 0; d313 = -118/(8415*pi); d314 = 0; d315 = -466/(46189*pi);

d45 = 0; d46 = -34/(99*pi); d47 = 0; d48 = -158/(2145*pi); d49 = 0; d410 = -46/(1365*pi);
d411= 0; d412 = -106/(5355*pi); d413 = 0; d414 = -422/(31977*pi); d415 = 0;

d56 = 0; d57 = -146/(429*pi); d58 = 0; d59 = -14/(195*pi); d510 = 0; d511 = -58/(1785*pi);
d512= 0; d513 = -386/(20349*pi); d514 = 0; d515 = -166/(13167*pi);

d67 = 0; d68 = -22/(65*pi); d69 = 0; d610 = -6/(85*pi); d611 = 0; d612 = -358/(11305*pi);
d613 = 0; d614 = -22/(1197*pi); d615 = 0;

d78 = 0; d79 = -86/(255*pi); d710 = 0; d711 = -338/(4845*pi); d712 = 0; d713 = -62/(1995*pi);
d714 = 0; d715 = -26/(1449*pi);

d89 = 0; d810 = -326/(969*pi); d811= 0; d812 = -46/(665*pi); d813 = 0; d814 = -74/(2415*pi);
d815= 0;

d910 = 0; d911 = -134/(399*pi); d912 = 0; d913 = -166/(2415*pi); d914 = 0; d915 = -122/(4025*pi);

d1011 = 0; d1012 = -54/(161*pi); d1013 = 0; d1014 = -118/(1725*pi); d1015 = 0;

d1112 = 0; d1113 = -578/(1725*pi); d1114 = 0; d1115 = -46/(675*pi);

d1213 = 0; d1214= -226/(675*pi); d1215= 0;

d1314 = 0; d1315 = -262/(783*pi);

d1415= 0;

/* symmetric matrix of coefficients d_{ii} and d_{ij} */

d_vec_7 = 
d00|
d01|d11|
d02|d12|d22|
d03|d13|d23|d33|
d04|d14|d24|d34|d44|
d05|d15|d25|d35|d45|d55|
d06|d16|d26|d36|d46|d56|d66|
d07|d17|d27|d37|d47|d57|d67|d77;

B_matrix = xpnd(d_vec_7);

/* bandwidth for z */

bandw = 1.06*stdc(z)*T^(-1/5);

/* First step estimator */

/* shifted Chebyshev polynomial of the first kind of order 0 */ 

phi0 = 1./sqrt(pi).*ones(T,1);

/* shifted Chebyshev polynomial of the first kind of order 1 */ 

phi1 = (-1+2.*obs[.,2])./sqrt(pi/2);

/* shifted Chebyshev polynomial of the first kind of order 2 */ 

phi2 = (1-8.*obs[.,2]+8.*obs[.,2]^2)./sqrt(pi/2);

/* shifted Chebyshev polynomial of the first kind of order 3 */ 

phi3 = (-1+18.*obs[.,2]-48.*obs[.,2]^2+32.*obs[.,2]^3)./sqrt(pi/2);

/* shifted Chebyshev polynomial of the first kind of order 4 */ 

phi4 = (1-32.*obs[.,2]+160.*obs[.,2]^2-256.*obs[.,2]^3+128.*obs[.,2]^4)./sqrt(pi/2);

/* shifted Chebyshev polynomial of the first kind of order 5 */ 

phi5 = (-1+50.*obs[.,2]-400.*obs[.,2]^2+1120.*obs[.,2]^3-1280.*obs[.,2]^4+512.*obs[.,2]^5)./sqrt(pi/2);

/* shifted Chebyshev polynomial of the first kind of order 6 */ 

phi6 = (1-72.*obs[.,2]+840.*obs[.,2]^2-3584.*obs[.,2]^3+6912.*obs[.,2]^4-6144.*obs[.,2]^5+2048.*obs[.,2]^6)./sqrt(pi/2);

/* shifted Chebyshev polynomial of the first kind of order 7 */ 

phi7 = (-1+98.*obs[.,2]-1568.*obs[.,2]^2+9408.*obs[.,2]^3-26880.*obs[.,2]^4+39424.*obs[.,2]^5-28672.*obs[.,2]^6+8192.*obs[.,2]^7)./sqrt(pi/2);


/* estimation of density of Z : denominator of nonparametric regression curve */

dens = sumc(pdfn((obs[.,3]-(ones(T,1).*.obs[.,3]'))/bandw));

/* estimation of r_hat */

vec_r = sumc(obs[.,1].*pdfn((obs[.,3]-(ones(T,1).*.obs[.,3]'))/bandw));

r_hat = vec_r./dens;

/* estimation of P_hat */

/* vector of numerator in regression curves */

vec_phi0 = sumc(phi0.*pdfn((obs[.,3]-(ones(T,1).*.obs[.,3]'))/bandw));
vec_phi1 = sumc(phi1.*pdfn((obs[.,3]-(ones(T,1).*.obs[.,3]'))/bandw));
vec_phi2 = sumc(phi2.*pdfn((obs[.,3]-(ones(T,1).*.obs[.,3]'))/bandw));
vec_phi3 = sumc(phi3.*pdfn((obs[.,3]-(ones(T,1).*.obs[.,3]'))/bandw));
vec_phi4 = sumc(phi4.*pdfn((obs[.,3]-(ones(T,1).*.obs[.,3]'))/bandw));
vec_phi5 = sumc(phi5.*pdfn((obs[.,3]-(ones(T,1).*.obs[.,3]'))/bandw));
vec_phi6 = sumc(phi6.*pdfn((obs[.,3]-(ones(T,1).*.obs[.,3]'))/bandw));
vec_phi7 = sumc(phi7.*pdfn((obs[.,3]-(ones(T,1).*.obs[.,3]'))/bandw));

/* estimation of P_hat */

P_hat = (vec_phi0~vec_phi1~vec_phi2~vec_phi3~vec_phi4~vec_phi5~vec_phi6~vec_phi7)./dens;

/* computation of estimated theta with pilot parameter */

theta_tilde = inv(p_lambda*D_matrix + P_hat'P_hat/T)*P_hat'r_hat/T;

/* Computation of conditional variance */

/* estimation of second moment */

vec_sto_mom2 = (obs[.,1] - phi0.*theta_tilde[1] - phi1.*theta_tilde[2] - phi2.*theta_tilde[3] - phi3.*theta_tilde[4]
- phi4.*theta_tilde[5] - phi5.*theta_tilde[6] - phi6.*theta_tilde[7] - phi7.*theta_tilde[8])^2; 

vec_mom2 = sumc(vec_sto_mom2.*pdfn((obs[.,3]-(ones(T,1).*.obs[.,3]'))/bandw));

mom2_hat = vec_mom2./dens;

/* estimation of first moment */

vec_sto_mom1 = (obs[.,1] - phi0.*theta_tilde[1] - phi1.*theta_tilde[2] - phi2.*theta_tilde[3] - phi3.*theta_tilde[4]
- phi4.*theta_tilde[5] - phi5.*theta_tilde[6] - phi6.*theta_tilde[7]- phi7.*theta_tilde[8]); 

vec_mom1 = sumc(vec_sto_mom1.*pdfn((obs[.,3]-(ones(T,1).*.obs[.,3]'))/bandw));

mom1_hat = vec_mom1./dens;

/* estimated conditional variance */

vari_est = mom2_hat - (mom1_hat)^2; 

/* estimation of r_hat weighted */

r_hat_weight = r_hat./sqrt(vari_est);

/* estimation of P_hat weighted*/

P_hat_weight = P_hat./sqrt(vari_est);

/* computation of estimated theta with pilot parameter and weight*/

theta_tilde_weight = inv(p_lambda*D_matrix + P_hat_weight'P_hat_weight/T)*P_hat_weight'r_hat_weight/T;

/* Spectral decomposition */

alpha_tilde = P_hat_weight'P_hat_weight/T;

N = D_inv*alpha_tilde;

{nu,w}=eigv(N);

w = w./sqrt( diag(w'D_matrix*w) )';

norm_squared_psi = zeros(8,1);

i=1;
do until i> 8;
  norm_squared_psi[i] = w[.,i]'B_matrix*w[.,i] ;
  i=i+1;
endo;

/* Initializing vectors to stock results */


vari_grid = zeros(grid_size,1);
bias_grid = zeros(grid_size,1);
MISE_grid = zeros(grid_size,1);

vari_grid_size = zeros(grid_size,grid_sample);
bias_grid_size = zeros(grid_size,1);
MISE_grid_size = zeros(grid_size,grid_sample);

/* starting the loop on grid */

for l(1,grid_size,1);

lambda = grid_lambda[l];

/* variance term */

   vari =0;
    i=1;
    do until i>8;
        vari = vari + nu[i]*norm_squared_psi[i]./ (lambda + nu[i] )^2;
        i=i+1;
  endo;
 
vari_grid[l] = vari/T;

/* bias term */

    A_matrix=invpd( alpha_tilde + lambda*D_matrix );
    A_matrix= A_matrix*alpha_tilde - eye(8);
    bias=theta_tilde_weight'A_matrix'B_matrix*A_matrix*theta_tilde_weight;
    
bias_grid[l] = bias;

/* Computation of spectral MISE */

MISE_grid[l] =  vari_grid[l] + bias_grid[l];

endfor;

/* Optimal spectral MISE, Lambda and ISE*/

MISE_opt = minc(MISE_grid);

lambda_opt = sumc(grid_lambda.*(MISE_grid .eq (MISE_opt))); 

theta_est = inv(lambda_opt*D_matrix + P_hat_weight'P_hat_weight/T)*P_hat_weight'r_hat_weight/T;

/* OLS estimate for alpha */

y_vec = ln(nu);
x_vec = ones(8,1)~j_vec;

beta_alpha = inv(x_vec'x_vec)*x_vec'y_vec;

alpha_opt = -beta_alpha[2]; 

/* OLS estimate for beta */

y_vec = ln(norm_squared_psi);
x_vec = ones(8,1)~ln(j_vec);

beta_beta = inv(x_vec'x_vec)*x_vec'y_vec;

beta_opt = -beta_beta[2]; 

/* OLS estimate for delta */

/* starting the loop on grid */

for l(1,grid_size,1);

lambda = grid_lambda[l];

/* variance term */

   vari =0;
    i=1;
    do until i>8;
        vari = vari + nu[i]*norm_squared_psi[i]./ (lambda + nu[i] )^2;
        i=i+1;
  endo;
 
vari_grid_size[l,.] = vari/grid_sample_size';

/* bias term */

    A_matrix=invpd( alpha_tilde + lambda*D_matrix );
    A_matrix= A_matrix*alpha_tilde - eye(8);
    bias=theta_est'A_matrix'B_matrix*A_matrix*theta_est;
    
bias_grid_size[l] = bias;

/* Computation of spectral MISE */

MISE_grid_size[l,.] =  vari_grid_size[l,.] + bias_grid_size[l];

endfor;

MISE_opt_size = minc(MISE_grid_size)';

lambda_opt_size = sumc(grid_lambda.*(MISE_grid_size .eq (MISE_opt_size)))'; 

/* regression */

y_vec = ln(lambda_opt_size');
x_vec = ones(grid_sample,1)~ln(grid_sample_size);

beta = inv(x_vec'x_vec)*x_vec'y_vec;

gamma_opt =-beta[2];

delta_opt = (1-gamma_opt)/2/gamma_opt;

print "end time" time;
time_end = time;
output off; 

/* computations of estimated functions */

/* grid on [0,1] */

xx = seqa(0.01,.01,99);
xxx = cdfni(xx);

/* xxx = (cdfni(xx).*st_xstar)+ave_xstar; */
/*
xxx = seqa(6.5,.05,(12.5-6.5)/.05+1);
xx = cdfn((xxx-ave_xstar)/st_xstar);
*/

/* shifted Chebyshev polynomial of the first kind of order 0 */ 

phi0 = 1./sqrt(pi);

/* shifted Chebyshev polynomial of the first kind of order 1 */ 

phi1 = (-1+2.*xx)./sqrt(pi/2);

/* shifted Chebyshev polynomial of the first kind of order 2 */ 

phi2 = (1-8.*xx+8.*xx^2)./sqrt(pi/2);

/* shifted Chebyshev polynomial of the first kind of order 3 */ 

phi3 = (-1+18.*xx-48.*xx^2+32.*xx^3)./sqrt(pi/2);

/* shifted Chebyshev polynomial of the first kind of order 4 */ 

phi4 = (1-32.*xx+160.*xx^2-256.*xx^3+128.*xx^4)./sqrt(pi/2);

/* shifted Chebyshev polynomial of the first kind of order 5 */ 

phi5 = (-1+50.*xx-400.*xx^2+1120.*xx^3-1280.*xx^4+512.*xx^5)./sqrt(pi/2);

/* shifted Chebyshev polynomial of the first kind of order 6 */ 

phi6 = (1-72.*xx+840.*xx^2-3584.*xx^3+6912.*xx^4-6144.*xx^5+2048.*xx^6)./sqrt(pi/2);

/* shifted Chebyshev polynomial of the first kind of order 7 */ 

phi7 = (-1+98.*xx-1568.*xx^2+9408.*xx^3-26880.*xx^4+39424.*xx^5-28672.*xx^6+8192.*xx^7)./sqrt(pi/2);


/* estimated function*/

y_est=phi0.*theta_est[1] + phi1.*theta_est[2] + phi2.*theta_est[3] + phi3.*theta_est[4]
+ phi4.*theta_est[5] + phi5.*theta_est[6] + phi6.*theta_est[7]+ phi7.*theta_est[8]; 

/* drawing the graph */

graphset;
/* format /rdn 8,2; */
_pdate = "";
title("Engel curve"); 
begwind;
window(1,2,0);
_plwidth = 15;
/*_pcolor = 2;*/
xlabel("x");
ylabel("estimated function");
xy(xx,y_est);
nextwind;
xlabel("xstar");
ylabel("estimated function");
xy(xxx,y_est);
endwind;

/* output file results */

output on;
output file= "C:\Documents and Settings\OScaillet\Mes documents\gausspgm\data_Hausman\TiR_estimation\fig_TiR_HS_7.out" reset;
print "x in [0,1]";
xx;
print "xstar in R";
xxx;
print "estimated function";
y_est;
output off;

format /rdn 8,5;

output on;
output file= "C:\Documents and Settings\OScaillet\Mes documents\gausspgm\data_Hausman\TiR_estimation\TiR_HS_7.out" reset;
print "linear case: sobolev norm";
print "closed form";
print "Sample size";
T;
print "MISE opt";
MISE_opt;
print "lambda opt";
lambda_opt;
print "alpha opt";
alpha_opt;
print "beta opt";
beta_opt;
print "gamma opt";
gamma_opt;
print "delta opt";
delta_opt;
print "Starting time";
time_start;
print "end time";
time_end;
output off;

closeall;
end;


