/* Estimation of functional parameter g */
/* Data of HS */
/* Parametric IVQR */
/* Support of g : [0,1] */
/* Instrumental variable Z */
/* criterion: minimum distance criterion with two polynomials */
/* Chebyshev polynomials of order 0 to 1 */
/* File name : parametric_HS.prg */

new;
library pgraph, optmum;
#include pgraph.ext;
#include optmum.ext

screen on;
print "Starting time" time;
time_start = time;

/* quantile probability level tau */

tau = 0.25;

load ixdtechg[18620,1] = "C:\\Documents and Settings\\OScaillet\\Mes documents\\gausspgm\\data_Hausman\\ixdtechg.txt";
load ixdtemin[18620,1] = "C:\\Documents and Settings\\OScaillet\\Mes documents\\gausspgm\\data_Hausman\\ixdtemin.txt";

load agec[18620,1] = "C:\\Documents and Settings\\OScaillet\\Mes documents\\gausspgm\\data_Hausman\\agec.txt";
load incomec[18620,1] = "C:\\Documents and Settings\\OScaillet\\Mes documents\\gausspgm\\data_Hausman\\incomec.txt";

load edhhc[18620,1] = "C:\\Documents and Settings\\OScaillet\\Mes documents\\gausspgm\\data_Hausman\\edhhc.txt";

load att[18620,1] = "C:\\Documents and Settings\\OScaillet\\Mes documents\\gausspgm\\data_Hausman\\att.txt";
load mci[18620,1] = "C:\\Documents and Settings\\OScaillet\\Mes documents\\gausspgm\\data_Hausman\\mci.txt";
load sprint[18620,1] = "C:\\Documents and Settings\\OScaillet\\Mes documents\\gausspgm\\data_Hausman\\sprint.txt"; 


interlata = ixdtechg ./  ixdtemin;
lmins = ixdtemin;
lincomec = ln(incomec);

/* Y, X, Z */

/* selection of variables based on years of education, operator, age */

/* e = (interlata .gt 0) .and (interlata .le 1) .and (edhhc .le 12) .and (att .gt 0) .and (agec .ge 30) .and (agec .le 45); */

e = (interlata .gt 0) .and (interlata .le 1) .and (edhhc .gt 12) .and (att .gt 0) .and (agec .ge 30) .and (agec .le 45); 

/* mapping of standardized data of Ystar, Xstar, Zstar in [0,1] via N(0,1) cdf */

ystar = selif(interlata, e);
/* y = cdfn((ystar-meanc(ystar))/stdc(ystar)); */
y = ystar;

xstar = selif(lmins, e);
x = cdfn((xstar-meanc(xstar))/stdc(xstar));

zstar = selif(lincomec, e); 
z = cdfn((zstar-meanc(zstar))/stdc(zstar));

/* Observed data */

obs = y~x~z;

/* Sample size */

T = rows(obs);

/* vector of : j = 1,2*/

j_vec = {1,2};

/* computations of Sobolev norm */

/* coefficients c_{ii} of theta_i^2 of the quadratic form in theta */

c00 = 1/pi; c11 = 26/(3*pi); 

/* coefficients c_{ij} of 2 theta_i theta_j , i \neq j, of the quadratic form in theta */

c01 = 0;

/* symmetric matrix of coefficients c_{ii} and c_{ij} */

c_vec_1 = 
c00|
c01|c11;

D_matrix = xpnd(c_vec_1);

D_inv = invpd(D_matrix);

/* computations of L2 norm */

/* coefficients d_{ii} of theta_i^2 of the quadratic form in theta */

d00 = 1/(pi); d11 = 2/(3*pi); 

/* coefficients d_{ij} of 2 theta_i theta_j , i \neq j, of the quadratic form in theta */

d01 = 0; 

/* symmetric matrix of coefficients d_{ii} and d_{ij} */

d_vec_1 = 
d00|
d01|d11;

B_matrix = xpnd(d_vec_1);

/* bandwidth for y */

hy = 1.06*stdc(obs[.,1])*T^(-1/5);

/* bandwidth for x */

hx = 1.06*stdc(obs[.,2])*T^(-1/5);

/* bandwidth for z */

hz = 1.06*stdc(obs[.,3])*T^(-1/5);

bandw = hz;

lambda_opt = 0;

lambda = lambda_opt;

/* computation of estimated theta */

/* estimation of theta */

start_theta = {0,0};
_opgdprc = &grad_crit;
_ophsprc = &hess_crit;
_opmiter = 150;
/*_opdirtol = 10^(-1);*/
__output=0;
{theta_est, f,g,retcode} = optmum(&crit, start_theta);

if retcode .eq 0;
theta_est = theta_est;
else;
theta_est = start_theta;
endif;

print "end time" time;
time_end = time;
output off; 

/* computations of estimated functions */

/* grid on [0,1] */

xx = seqa(0.01,.01,99);
xxx = cdfni(xx);

/* xxx = (cdfni(xx).*st_xstar)+ave_xstar; */
/*
xxx = seqa(6.5,.05,(12.5-6.5)/.05+1);
xx = cdfn((xxx-ave_xstar)/st_xstar);
*/

/* shifted Chebyshev polynomial of the first kind of order 0 */ 

phi0 = 1./sqrt(pi);

/* shifted Chebyshev polynomial of the first kind of order 1 */ 

phi1 = (-1+2.*xx)./sqrt(pi/2);

/* estimated function*/

y_est=phi0.*theta_est[1] + phi1.*theta_est[2]; 

/* drawing the graph */

graphset;
/* format /rdn 8,2; */
_pdate = "";
title("Engel curve"); 
begwind;
window(1,2,0);
_plwidth = 15;
/*_pcolor = 2;*/
xlabel("x");
ylabel("estimated function");
xy(xx,y_est);
nextwind;
xlabel("xstar");
ylabel("estimated function");
xy(xxx,y_est);
endwind;

/* output file results */

output on;
output file= "C:\Documents and Settings\OScaillet\Mes documents\gausspgm\data_Hausman\QTiR_estimation\parametric_HS\fig_parametric_HS_25_well.out" reset;
print "x in [0,1]";
xx;
print "xstar in R";
xxx;
print "estimated function";
y_est;
output off;

output on;
output file= "C:\Documents and Settings\Oscaillet\Mes documents\gausspgm\data_Hausman\QTiR_estimation\parametric_HS\parametric_HS_25_well.out" reset;
print "linear case: sobolev norm";
print "closed form";
print "Sample size";
print"tau";
tau;
print "sample size";
T;
print "lambda opt";
lambda_opt;
print " estimated theta ";
theta_est;
print "Starting time";
time_start;
print "end time";
time_end;
output off;

closeall;
end;

/* PROCEDURES */

/* COMPUTATIONS OF CHEBYSHEV POLYNOMIALS */ 

/* shifted Chebyshev polynomial of the first kind of order 0 */ 

proc poly0(x);
retp(1./sqrt(pi).*x);
endp;

/* shifted Chebyshev polynomial of the first kind of order 1 */ 

proc poly1(x);
retp((-1+2.*x)./sqrt(pi/2));
endp;

/* COMPUTATIONS OF PENALIZED CRITERION */

/* penalized criterion : Q_T(theta) + lambda theta' D theta */

proc crit(theta);
local crit;
crit = (P_hat(theta,obs[.,1],obs[.,2],obs[.,3]) - tau)'(P_hat(theta,obs[.,1],obs[.,2],obs[.,3]) - tau)/T/(tau.*(1-tau)) + lambda.* theta'*D_matrix*theta;
retp(crit);
endp; 

/* estimation of density of Z : denominator of conditional density */

proc dens(z);
retp(sumc(pdfn((z-(ones(T,1).*.z'))/hz)));
endp;

/* T X 1 vector P hat  */

proc P_hat(theta,y,x,z);
local nume, deno, sto, poly;
poly = poly0(ones(T,1))~poly1(x);
sto = -(y-poly*theta)/hy;
nume = sumc(cdfn(sto).*pdfn((z-(ones(T,1).*.z'))/hz)); 
deno = dens(z);
retp(nume./deno);
endp;

/* T X k vector gradient of P hat  */

proc grad_P_hat(theta,y,x,z);
local grad_Phat, sto, poly, deno, nume0, grad0, nume1, grad1;
poly = poly0(ones(T,1))~poly1(x);
sto = -(y-poly*theta)/hy;
deno = dens(z);
nume0 = sumc(poly0(ones(T,1))/hy.*pdfn(sto).*pdfn((z-(ones(T,1).*.z'))/hz)); 
grad0 = nume0./deno;
nume1 = sumc(poly1(x)/hy.*pdfn(sto).*pdfn((z-(ones(T,1).*.z'))/hz)); 
grad1 = nume1./deno; 
grad_Phat = grad0~grad1;
retp(grad_Phat);
endp;

/* 1 X k vector gradient of penalized criterion  */

proc grad_crit(theta);
local grd, grad;
grad = 2*grad_P_hat(theta,obs[.,1],obs[.,2],obs[.,3])'(P_hat(theta,obs[.,1],obs[.,2],obs[.,3]) - tau)/T/(tau.*(1-tau));
grd = grad + 2*lambda.*D_matrix*theta;
retp(grd');
endp;

/* T X (k (k+1)/2) vector gradient^2 and cross product of P hat  */

proc grad2_P_hat(theta,y,x,z);
local grad2_Phat, zz, sto, poly, deno, nume, grad;
poly = poly0(ones(T,1))~poly1(x);
zz = vech((eye(T).*.ones(2,2)).*(vecr(poly)*vecr(poly)'));
zz = delif(zz, zz.eq 0);
zz = reshape(zz,T,2*(2+1)/2);
sto = -(y-poly*theta)/hy;
deno = dens(z);
nume = sumc(zz/(hy^2).*(-sto).*pdfn(sto)*~pdfn((z-(ones(T,1).*.z'))/hz)); 
nume = reshape(nume,2*(2+1)/2,T)';
grad = nume./deno; 
grad2_Phat = grad;
retp(grad2_Phat);
endp;

/* k X k vector Hessian of penalized criterion  */

proc hess_crit(theta);
local hessian, sto1, sto2, sto3;
sto1 =  grad2_P_hat(theta,obs[.,1],obs[.,2],obs[.,3]);
sto2 = grad_P_hat(theta,obs[.,1],obs[.,2],obs[.,3]);
sto2 = vech((eye(T).*.ones(2,2)).*(vecr(sto2)*vecr(sto2)'));
sto2 = delif(sto2, sto2 .eq 0);
sto2 = reshape(sto2,T,2*(2+1)/2);
sto3 = 2.*sumc(sto1.*(P_hat(theta,obs[.,1],obs[.,2],obs[.,3])-tau)+sto2)/T/(tau.*(1-tau));
hessian = xpnd(sto3) + 2*lambda*D_matrix;
retp(hessian);
endp;







